
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <dirent.h>
#include <sys/stat.h>

static void	Error(msg)
char		*msg;
{
	fputs(msg,stderr); fputc('\n',stderr); exit(1);
}

static void	CheckSum(name,len,sum)
char		*name;
int		*len,*sum;
{
	FILE	*file=fopen(name,"rb");
	int	l=0,s=0;

	if (file==NULL)
	    fprintf(stderr,"%s : file read error.\n",name);
	else {
#ifdef	BUFLEN
	unsigned char	buf[BUFLEN],*ptr;
	int		cnt;

	    while ((cnt=fread(buf,1,BUFLEN,file))>0)
	    for (ptr=buf; --cnt>=0; ptr++) { ++l; s+=(int)*ptr; }
#else
	int	code;

	    while ((code=fgetc(file))!=EOF) { ++l; s+=code; }
#endif
	    *len+=l; *sum+=s; fclose(file);

	    printf("%s\t%d\t%d\n",name,l,s&0xff);
	}
}

static void	CountCheckSum(path,num,len,sum)
char		*path;
int		*num,*len,*sum;
{
	DIR		*d;
	struct dirent	*e;
	int		l2=strlen(path)+2;
	char		*name;
	struct stat	s;

	if ((d=opendir(path))==NULL) {
	    fprintf(stderr,"%s : directory read error.\n",path); return;
	}
	while ((e=readdir(d))!=NULL) {
	    if (!strcmp(e->d_name,".") || !strcmp(e->d_name,"..")) continue;

	    if ((name=(char *)malloc(l2+strlen(e->d_name)))==NULL)
		Error("name area allocation error.");

	    sprintf(name,"%s/%s",path,e->d_name);
	    if (stat(name,&s)==(-1))
		fprintf(stderr,"%s : status read error.\n",name);
	    else
		if ((s.st_mode&S_IFMT)==S_IFDIR)
		    CountCheckSum(name,num,len,sum);
		else {
		    ++(*num); CheckSum(name,len,sum);
		}

	    free(name);
	}
	closedir(d);
}

static void	PrintCheckSum(path)
char		*path;
{
	int	num=0,len=0,sum=0;

	CountCheckSum(path,&num,&len,&sum);

	printf("%s/\t%d\t%d\t%d\n",path,num,len,sum&0xff);
}

int	main(argc,argv)
int	argc;
char	**argv;
{
	if (argc==1)
	    PrintCheckSum(".");
	else
	    while (--argc>0) PrintCheckSum(*(++argv));

	return 0;
}
