
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <dirent.h>
#include <sys/stat.h>

static void	Error(msg)
char		*msg;
{
	fputs(msg,stderr); fputc('\n',stderr); exit(1);
}

static void	DumpDirectory(path,level)
char		*path;
int		level;
{
	DIR		*d;
	struct dirent	*e;
	int		l2=strlen(path)+2;
	char		*name;
	struct stat	s;

	if ((d=opendir(path))==NULL) {
	    fprintf(stderr,"%s : directory read error.\n",path); return;
	}
	while ((e=readdir(d))!=NULL) {
	    if (!strcmp(e->d_name,".") || !strcmp(e->d_name,"..")) continue;

	    if ((name=(char *)malloc(l2+strlen(e->d_name)))==NULL)
		Error("name area allocation error.");

	    sprintf(name,"%s/%s",path,e->d_name);
	    if (stat(name,&s)==(-1))
		fprintf(stderr,"%s : status read error.\n",name);
	    else
		if ((s.st_mode&S_IFMT)==S_IFDIR) {
		    printf("%s/\n",name);

		    if (level>1) DumpDirectory(name,level-1);
		}
		else
		    printf("%s\t%ld\n",name,(long)s.st_size);

	    free(name);
	}
	closedir(d);
}

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	level=0x7ffffff;

	if (argc>1 && argv[1][0]=='-') {
	    if ((level=atoi(&(argv[1][1])))<=0)
		Error("usage : dmpdir {-recursionLevel} {directories}");

	    --argc; ++argv;
	}
	if (argc==1)
	    DumpDirectory(".",level);
	else
	    while (--argc>0) DumpDirectory(*(++argv),level);

	return 0;
}
