
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <time.h>
#include <dirent.h>

#ifdef	__MSVCRT__
#define stat	_stati64
#define LLU	"%I64u"
#else
#define LLU	"%llu"
#endif

#ifndef FST_TIME
#define FST_TIME	st_mtime	/* member of struct stat */
#endif

static void	FST(unsigned long long level,char *Path)
{
	struct stat	s;
	struct tm	*t;
	DIR		*d;
	size_t		l;
	struct dirent	*e;
	char		*path;

	if (stat(Path,&s)==(-1))
	    (void)fprintf(stderr,"%s : status read error.\n",Path);
	else if ((s.st_mode&S_IFMT)!=S_IFDIR) {
	    t=localtime(&(s.FST_TIME));
	    (void)printf("%s\t%s" LLU "\t%04d.%02d.%02d.%02d.%02d.%02d\n",
			 Path,
			 ((s.st_mode&S_IFMT)!=S_IFREG)?"-":"",
			 (unsigned long long)s.st_size,
			 t->tm_year+1900,
			 t->tm_mon+1,
			 t->tm_mday,
			 t->tm_hour,
			 t->tm_min,
			 t->tm_sec);
	}
	else if (level>0)
	    if ((d=opendir(Path))==NULL)
		(void)fprintf(stderr,"%s : directory read error.\n",Path);
	    else {
		l=strlen(Path)+2;
		while ((e=readdir(d))!=NULL)
		    if (strcmp(e->d_name,".") && strcmp(e->d_name,"..")) {
			if ((path=(char *)malloc(l+strlen(e->d_name)))==NULL) {
			    (void)fputs("memory allocation error.\n",stderr);
			    exit(1);
			}
			(void)sprintf(path,"%s/%s",Path,e->d_name);
			FST(level-1,path);
			free(path);
		    }

		(void)closedir(d);
	    }
}

int	main(int argc,char **argv)
{
	unsigned long long	level=(unsigned long long)(~0);

	if (argc>1 && argv[1][0]=='-') {
	    if (sscanf(argv[1]+1,LLU,&level)!=1 || level==0) {
		(void)fputs("usage : fst {-searchLevel} {paths}\n",stderr);
		exit(1);
	    }
	    --argc; ++argv;
	}
	if (argc==1)
	    FST(level,".");
	else
	    while (--argc>0) FST(level,*(++argv));

	return 0;
}
