
#include <stdio.h>
#include <stdlib.h>
#include <setjmp.h>

#define DEFAULT_WID	0L
#define DEFAULT_HIG	0L
#define DEFAULT_SPP	1
#define DEFAULT_BPS	1

static jmp_buf	env;

static int	FGetC(file)
FILE		*file;
{
	int	code;

	if ((code=fgetc(file))==EOF) longjmp(env,1); return code;
}

static void	FSeek(file,offset,origin)
FILE		*file;
long		offset;
int		origin;
{
	if (fseek(file,offset,origin)) longjmp(env,2);
}

typedef	unsigned short	Word2;
typedef unsigned long	Word4;

static Word2	Get2I(tiff)
FILE		*tiff;
{
	Word2	lo=(Word2)FGetC(tiff);

	return lo|((Word2)FGetC(tiff)<<8);
}

static Word4	Get4I(tiff)
FILE		*tiff;
{
	Word4	lo=(Word4)Get2I(tiff);

	return lo|((Word4)Get2I(tiff)<<16);
}

static Word2	Get2M(tiff)
FILE		*tiff;
{
	Word2	hi=(Word2)FGetC(tiff);

	return (hi<<8)|(Word2)FGetC(tiff);
}

static Word4	Get4M(tiff)
FILE		*tiff;
{
	Word4	hi=(Word4)Get2M(tiff);

	return (hi<<16)|(Word4)Get2M(tiff);
}

#define ERROR(msg)	fprintf(stderr,"%s : %s\n",path,msg)

static void	PrintImageGeometry(path)
char		*path;
{
	FILE	*tiff;
	int	code;
	Word2	(*Get2)(),cnt,spp,bps[4],tag,typ;
	Word4	(*Get4)(),ifd,wid,hig,idx,len,*ptr,pos;

	if ((tiff=fopen(path,"rb"))==NULL) {
	    ERROR("file not found."); return;
	}
	if (setjmp(env)) {
	    fclose(tiff); ERROR("unexpected end of file."); return;
	}
	switch(code=FGetC(tiff)) {
	    case 'I' : Get2=Get2I; Get4=Get4I; break;
	    case 'M' : Get2=Get2M; Get4=Get4M; break;
	    default  : code=0; break;
	}
	if (!code || FGetC(tiff)!=code || (*Get2)(tiff)!=0x002a) {
	    fclose(tiff); ERROR("bad magic number."); return;
	}
	while (ifd=(*Get4)(tiff)) {
	    FSeek(tiff,ifd,0);
	    wid=DEFAULT_WID;
	    hig=DEFAULT_HIG;
	    spp=DEFAULT_SPP; bps[0]=DEFAULT_BPS; idx=1L;
	    for (cnt=(*Get2)(tiff); cnt; cnt--) {
		tag=(*Get2)(tiff); typ=(*Get2)(tiff); len=(*Get4)(tiff);
		switch(tag) {
		    case 0x100 :
		    case 0x101 :
			if ((typ==3 || typ==4) && len==1L) {
			    ptr=(tag==0x100)?&wid:&hig;
			    if (typ==3) {
				*ptr=(Word4)(*Get2)(tiff); FSeek(tiff,2L,1);
			    }
			    else
				*ptr=(*Get4)(tiff);
			}
			else
			    FSeek(tiff,4L,1); break;
		    case 0x102 :
			if (typ==3 && len<=4L) {
			    pos=ftell(tiff);

			    if (len>=3L) FSeek(tiff,(*Get4)(tiff),0);
			    for (idx=0L; idx<len; idx++) bps[idx]=(*Get2)(tiff);

			    FSeek(tiff,pos+4L,0);
			}
			else
			    FSeek(tiff,4L,1); break;
		    case 0x115 :
			if (typ==3 && len==1L) {
			    spp=(*Get2)(tiff); FSeek(tiff,2L,1);
			}
			else
			    FSeek(tiff,4L,1); break;
		    default :
			FSeek(tiff,4L,1); break;
		}
	    }
	    printf("%ld\t%ld\t%d",wid,hig,spp);
	    for (len=0L; len<idx; len++) printf("\t%d",bps[len]);
	    putchar('\n');
	}
	fclose(tiff);
}

int	main(argc,argv)
int	argc;
char	**argv;
{
	if (argc==1) {
	    fputs("usage : pig TIFF {TIFF ...}\n",stderr); exit(1);
	}
	while (--argc) PrintImageGeometry(*(++argv)); return 0;
}
