
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <dirent.h>
#include <sys/stat.h>

#define PATH_MAX	2048

static void	SLink(path)
char		*path;
{
	int		l=strlen(path);
	DIR		*d;
	struct dirent	*e;
	char		name[PATH_MAX+1],link[PATH_MAX+1];
	struct stat	s;

	if ((d=opendir(path))==NULL) {
	    fprintf(stderr,"%s : directory read error.\n",path); return;
	}
	while ((e=readdir(d))!=NULL) {
	    if (!strcmp(e->d_name,".") || !strcmp(e->d_name,"..")) continue;

	    if (l+1+strlen(e->d_name)>PATH_MAX) {
		fprintf(stderr,"%s/%s : too long path name.\n",path,e->d_name);
		continue;
	    }
	    sprintf(name,"%s/%s",path,e->d_name);
	    if (lstat(name,&s)==(-1)) {
		fprintf(stderr,"%s : status read error.\n",name); continue;
	    }
	    switch(s.st_mode&S_IFMT) {
		case S_IFDIR :
		    SLink(name); break;
		case S_IFLNK :
		    memset(link,'\0',PATH_MAX+1);
		    if (readlink(name,link,PATH_MAX)==(-1)) {
			fprintf(stderr,"%s : link read error.\n",name); break;
		    }
		    printf("%s\t%s\n",name,link); break;
	    }
	}
	closedir(d);
}

int	main(argc,argv)
int	argc;
char	**argv;
{
	if (argc==1) SLink("."); else while (--argc>0) SLink(*(++argv));

	return 0;
}
