
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <dirent.h>
#include <sys/stat.h>

static void	Error(msg,inf)
char		*msg,*inf;
{
	fprintf(stderr,"%s%s\n",msg,inf); exit(1);
}

static int	Compare(name1,name2)
char		**name1,**name2;
{
	return strcmp(*name1,*name2);
}

static void	Print(count,name,symbol)
int		count;
char		*name,*symbol;
{
	while (--count>=0) putchar(' '); printf("%s%s\n",name,symbol);
}

static int	indent=2;

static void	Tree(path,left)
char		*path;
int		left;
{
	DIR		*d;
	int		num,idx,len,nameLen,pathLen=strlen(path)+1;
	struct dirent	*e;
	char		**name,*full,*ewamf="error when allocating memory for ";
	struct stat	s;

	if ((d=opendir(path))==NULL) Error("error when opening ",path);

	num=0;
	while ((e=readdir(d))!=NULL)
	    if (strcmp(e->d_name,".") && strcmp(e->d_name,"..")) ++num;

	if (num==0) {
	    closedir(d); return;
	}

	if ((name=(char **)calloc(num,sizeof(*name)))==NULL) Error(ewamf,path);

	rewinddir(d);

	idx=nameLen=0;
	while ((e=readdir(d))!=NULL) {
	    if (!strcmp(e->d_name,".") || !strcmp(e->d_name,"..")) continue;

	    len=strlen(e->d_name)+1;
	    if ((name[idx]=(char *)malloc(len))==NULL) Error(ewamf,path);

	    strcpy(name[idx],e->d_name); ++idx; if (len>nameLen) nameLen=len;
	}
	closedir(d);

	if ((full=(char *)malloc(pathLen+nameLen))==NULL) Error(ewamf,path);

	qsort(name,num,sizeof(*name),Compare);

	for (idx=0; idx<num; idx++) {
	    sprintf(full,"%s/%s",path,name[idx]);
	    if (stat(full,&s)==(-1))
		Error("error when reading the status of ",full);

	    if ((s.st_mode&S_IFMT)==S_IFDIR) {
		Print(indent+left,name[idx],""); Tree(full,indent+left);
	    }
	    else
		Print(indent+left,name[idx],(s.st_mode&S_IEXEC)?"*":"");

	    free(name[idx]);
	}
	free(full); free(name);
}

int	main(argc,argv)
int	argc;
char	**argv;
{
	char	*path,
		*usage="usage : tree {-indent} {path}",
		*badIndent="bad indent is assigned.",
		*defaultPath=".";

	switch(argc) {
	    case 1 : path=defaultPath; break;
	    case 2 :
		if (argv[1][0]=='-') {
		    if ((indent=atoi(&(argv[1][1])))<0) Error(badIndent,"");
		    path=defaultPath;
		}
		else
		    path=argv[1];
		break;
	    case 3 :
		if (argv[1][0]!='-') Error(usage,"");
		if ((indent=atoi(&(argv[1][1])))<0) Error(badIndent,"");
		path=argv[2];
		break;
	    default : Error(usage,"");
	}

	puts(path); Tree(path,0); return 0;
}
