#
# usage
#   ( echo Markers SCALE | awk -f marker.awk | check_marker SCALE - ) |& cat
# where
#   parameter SCALE = ratio | (Uxyz Uh Uv Ud) | (Ux Uy Uz Uh Uv Ud)
#  
BEGIN {
  Rad=atan2(1,1)/45
  if (unit=="") unit=500
  if (seed=="") srand(); else srand(seed)
}
function Rand() { return (rand()-0.5)*2 }
function Marker(N,Ux,Uy,Uz,Uh,Uv,Ud) {
  printf "%f\t",t=180*Rand() > "/dev/stderr"; t*=Rad; cosA=cos(t); sinA=sin(t)
  printf "%f\t",t=180*Rand() > "/dev/stderr"; t*=Rad; cosB=cos(t); sinB=sin(t)
  printf "%f\n",t=180*Rand() > "/dev/stderr"; t*=Rad; cosC=cos(t); sinC=sin(t)
  printf "%f\t",xh=       cosB*cosC           *Uh/Ux > "/dev/stderr"
  printf "%f\t",xv=      -cosB*sinC           *Uv/Ux > "/dev/stderr"
  printf "%f\n",xd=       sinB                *Ud/Ux > "/dev/stderr"
  printf "%f\t",yh=( sinA*sinB*cosC+cosA*sinC)*Uh/Uy > "/dev/stderr"
  printf "%f\t",yv=(-sinA*sinB*sinC+cosA*cosC)*Uv/Uy > "/dev/stderr"
  printf "%f\n",yd= -sinA*cosB                *Ud/Uy > "/dev/stderr"
  printf "%f\t",zh=(-cosA*sinB*cosC+sinA*sinC)*Uh/Uz > "/dev/stderr"
  printf "%f\t",zv=( cosA*sinB*sinC+sinA*cosC)*Uv/Uz > "/dev/stderr"
  printf "%f\n",zd=  cosA*cosB                *Ud/Uz > "/dev/stderr"
  for (n=0; n<N; n++) {
    h=unit*Rand()
    v=unit*Rand()
    d=unit*Rand(); printf "%f %f %f\t%f %f %f\n",x=xh*h+xv*v+xd*d, \
                                                 y=yh*h+yv*v+yd*d, \
                                                 z=zh*h+zv*v+zd*d,h,v,d
    if (n==0) {
      x1=x2=x; y1=y2=y; z1=z2=z
    }
    else {
      if (x<x1) x1=x; else if (x>x2) x2=x
      if (y<y1) y1=y; else if (y>y2) y2=y
      if (z<z1) z1=z; else if (z>z2) z2=z
    }
  }
  printf "%f\t%f\t%f\n=\n",x2-x1,y2-y1,z2-z1 > "/dev/stderr"
}
NF==2 { Marker($1,1,1,1,$2,$2,$2) }
NF==5 { Marker($1,$2,$2,$2,$3,$4,$5) }
NF==7 { Marker($1,$2,$3,$4,$5,$6,$7) }
