
#include <stdio.h>
#include <stdlib.h>
#include "cell.h"
#include "csi.h"
#include "rif_cm.h"
#include "sif_cm.h"

extern void	Error(),ReadSliceImage();

#define STR_LEN	1024

int	main(argc,argv)
int	argc;
char	**argv;
{
	char		**Px,**Py,form[STR_LEN],path[STR_LEN];
	int		H,V,D,h,v,d,Nx,Ny,BPS,len,X,Y;
	double		Bx,By,Sx,Sy,Lx,Ly,y,x;
	Cell		**Cxy,**Cx,**Cy,**Cz;
	unsigned short	*R,*G,*B;

	if (argc!=9)
	    Error("usage : si_pair_dm xDir xBase xStep"
				    " yDir yBase yStep xyTIFF zDir");

	Px=CheckSliceImages(argv[1],"-",&H,&V,&D,NULL);
	Py=CheckSliceImages(argv[4],"-",&h,&v,&d,NULL);
	if (H!=h || V!=v || D!=d) Error("size of [x,y]Dir not match.");

	Bx=atof(argv[2]);
	By=atof(argv[5]);
	if ((Sx=atof(argv[3]))<1.0 ||
	    (Sy=atof(argv[6]))<1.0) Error("bad pixel value step.");

	ReadImageFile_CM(argv[7],&Nx,&Ny,&BPS,&R,&G,&B,&Cxy,NULL);

	if ((Cx=(Cell **)malloc(sizeof(Cell *)*V))==NULL ||
	    (*Cx=(Cell *)malloc(sizeof(Cell)*V*H))==NULL ||
	    (Cy=(Cell **)malloc(sizeof(Cell *)*V))==NULL ||
	    (*Cy=(Cell *)malloc(sizeof(Cell)*V*H))==NULL)
	    Error("memory allocation error.");

	for (v=1; v<V; v++) {
	    Cx[v]=Cx[v-1]+H;
	    Cy[v]=Cy[v-1]+H;
	}
	len=1; for (d=10; d<D; d*=10) ++len;
	(void)sprintf(form,"%s/%%0%dd.tif",argv[8],len);

	Lx=Bx+Sx*(double)(X=Nx-1);
	Ly=By+Sy*(double)(Y=Ny-1); Cz=Cy;

	for (d=0; d<D; d++) {
	    ReadSliceImage(Px[d],H,V,Cx);
	    ReadSliceImage(Py[d],H,V,Cy);

	    for (v=0; v<V; v++)
	    for (h=0; h<H; h++)
	    Cz[v][h]=
	    Cxy[((y=((double)Cy[v][h]-By)/Sy)<0.0)?0:(y>=Ly)?Y:(int)(y+0.5)]
	       [((x=((double)Cx[v][h]-Bx)/Sx)<0.0)?0:(x>=Lx)?X:(int)(x+0.5)];

	    (void)sprintf(path,form,d);
	    StoreImageFile_CM(path,H,V,BPS,R,G,B,Cz,NULL);
	}
	return 0;
}
