
#include <stdio.h>
#include <stdlib.h>
#include "cell.h"
#include "rif_cm.h"
#include "sif_cm.h"

extern void	Error();

int	main(argc,argv)
int	argc;
char	**argv;
{
	int		H,V,h,v,Nx,Ny,BPS,X,Y;
	Cell		**Cx,**Cy,**Cxy,**Cz;
	double		Bx,By,Sx,Sy,Lx,Ly,y,x;
	unsigned short	*R,*G,*B;

	if (argc!=9)
	    Error("usage : t_pair_dm xTIFF xBase xStep"
				   " yTIFF yBase yStep xyTIFF zTIFF");

	ReadImageFile_CM(argv[1],&H,&V,NULL,NULL,NULL,NULL,&Cx,NULL);
	ReadImageFile_CM(argv[4],&h,&v,NULL,NULL,NULL,NULL,&Cy,NULL);
	if (H!=h || V!=v) Error("size of [x,y]TIFF not match.");

	Bx=atof(argv[2]);
	By=atof(argv[5]);
	if ((Sx=atof(argv[3]))<1.0 ||
	    (Sy=atof(argv[6]))<1.0) Error("bad pixel value step.");

	ReadImageFile_CM(argv[7],&Nx,&Ny,&BPS,&R,&G,&B,&Cxy,NULL);

	Lx=Bx+Sx*(double)(X=Nx-1);
	Ly=By+Sy*(double)(Y=Ny-1); Cz=Cx;

	for (v=0; v<V; v++)
	for (h=0; h<H; h++)
	    Cz[v][h]=
	    Cxy[((y=((double)Cy[v][h]-By)/Sy)<0.0)?0:(y>=Ly)?Y:(int)(y+0.5)]
	       [((x=((double)Cx[v][h]-Bx)/Sx)<0.0)?0:(x>=Lx)?X:(int)(x+0.5)];

	StoreImageFile_CM(argv[8],H,V,BPS,R,G,B,Cz,NULL);

	return 0;
}
