
#include <stdio.h>
#include <stdlib.h>
#include "cell.h"
#include "rif.h"

extern void	Error();

#ifdef	__MSVCRT__
#define FORMAT	"%I64u"
#else
#define FORMAT	"%llu"
#endif

#define PAIRS	unsigned long long

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	Nh,Nv,h,v,Nx,Ny,y,x;
	Cell	**Cx,**Cy;
	double	Bx,By,Sx,Sy,t;
	PAIRS	**pairs,largest;

	if (argc!=9) Error("usage : t_pair_hg xTIFF xBase xStep xPels"
					    " yTIFF yBase yStep yPels");

	ReadImageFile(argv[1],&Nh,&Nv,NULL,&Cx,NULL);
	ReadImageFile(argv[5],&h,&v,NULL,&Cy,NULL);
	if (h!=Nh || v!=Nv) Error("image size not match.");

	Bx=atof(argv[2]);
	By=atof(argv[6]);
	if ((Sx=atof(argv[3]))<1.0 ||
	    (Sy=atof(argv[7]))<1.0) Error("bad pixel value step.");

	if ((Nx=atoi(argv[4]))<1 ||
	    (Ny=atoi(argv[8]))<1) Error("bad number of pixels.");

	if ((pairs=(PAIRS **)malloc(sizeof(PAIRS *)*Ny))==NULL ||
	    (*pairs=(PAIRS *)malloc(sizeof(PAIRS)*Ny*Nx))==NULL)
	    Error("memory allocation error.");

	for (y=0; y<Ny; y++) {
	    if (y>0) pairs[y]=pairs[y-1]+Nx;

	    for (x=0; x<Nx; x++) pairs[y][x]=0;
	}
	for (v=0; v<Nv; v++)
	for (h=0; h<Nh; h++)
	    if ((t=(double)Cx[v][h]-Bx)>=0.0 && (x=(int)(t/Sx))>=0 && x<Nx &&
		(t=(double)Cy[v][h]-By)>=0.0 && (y=(int)(t/Sy))>=0 && y<Ny)
		++pairs[y][x];

	largest=0;
	for (y=0; y<Ny; y++)
	for (x=0; x<Nx; x++) if (pairs[y][x]>largest) largest=pairs[y][x];

	(void)printf("%d\t%d\t" FORMAT "\n",Nx,Ny,largest);

	for (y=0; y<Ny; y++)
	for (x=0; x<Nx; x++) (void)printf(FORMAT "\n",pairs[y][x]);

	return 0;
}
