
#include <stdio.h>
#include <stdlib.h>

static void	Error(msg)
char		*msg;
{
	(void)fputs(msg,stderr); (void)fputc('\n',stderr); exit(1);
}

static inline double	Sqr(xy)
double			xy;
{
	return xy*xy;
}

#define STR_LEN	1024

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	X,Y,**Z,z,v,h,m,n,N=0;
	FILE	*file;
	char	L[STR_LEN],*fnf=" : file not found.";
	double	x,y,s,t;

	struct Point {
		double	x,y;
		int	z;
	} *p,*P=NULL;

	if (argc!=4 && argc!=5)
	    Error("usage : voronoi_dm xPels yPels initial.txt {boundary.txt}");

	if ((X=atoi(argv[1]))<=0 ||
	    (Y=atoi(argv[2]))<=0) Error("bad map size.");

	if ((Z=(int **)malloc(sizeof(*Z)*Y))==NULL ||
	    (*Z=(int *)malloc(sizeof(**Z)*Y*X))==NULL)
	    Error("image memory allocation error.");

	if (argv[3][0]=='-')
	    file=stdin;
	else
	    if ((file=fopen(argv[3],"r"))==NULL) {
		(void)fputs(argv[3],stderr); Error(fnf);
	    }

	while (fgets(L,STR_LEN,file)!=NULL &&
	       sscanf(L,"%lf %lf %d",&x,&y,&z)==3 &&
	       z>=0) {
	    if ((P=(struct Point *)realloc(P,sizeof(*P)*(++N)))==NULL)
		Error("point memory allocation error.");

	    p=P+N-1; p->x=x; p->y=y; p->z=z;
	}
	if (file!=stdin) (void)fclose(file);

	if (N==0) Error("no Voronoi point.");

	for (v=0; v<Y; v++) {
	    if (v>0) Z[v]=Z[v-1]+X;

	    y=(double)v;
	    for (h=0; h<X; h++) {
		x=(double)h;

		p=P+(m=n=N-1); s=Sqr(x-p->x)+Sqr(y-p->y);
		for (--p; --n>=0; p--)
		    if ((t=Sqr(x-p->x)+Sqr(y-p->y))<s) {
			m=n; s=t;
		    }

		Z[v][h]=P[m].z;
	    }
	}
	free(P);

	if (argc==5) {
	    if (argv[4][0]=='-')
		file=stdin;
	    else
		if ((file=fopen(argv[4],"r"))==NULL) {
		    (void)fputs(argv[4],stderr); Error(fnf);
		}

	    while (fgets(L,STR_LEN,file)!=NULL &&
		   sscanf(L,"%lf %lf %d",&x,&y,&z)==3 &&
		   (h=(int)(x+0.5))>=0 && h<X &&
		   (v=(int)(y+0.5))>=0 && v<Y &&
		   z>=0) Z[v][h]=z;

	    if (file!=stdin) (void)fclose(file);
	}
	z=0;
	for (v=0; v<Y; v++)
	for (h=0; h<X; h++) if (z<Z[v][h]) z=Z[v][h];

	(void)printf("%d\t%d\t%d\n",X,Y,z);
	for (v=0; v<Y; v++)
	for (h=0; h<X; h++) (void)printf("%d\n",Z[v][h]);

	return 0;
}
