#!/bin/csh
# usage : bev_word.csh bin_size LAC_threshold
#
set lon=(0 10 36)	# longitude base, step and count
set lat=(90 10 19)	# latitude base, step and count
set gbbf=(1 64 255 0)	# gamma, bias, bg and fg
#
set tmp=/tmp/AAAa$$
#
if ($#argv != 2) then
  stderr usage : bev_word.csh bin_size LAC_threshold ; exit 1
endif
#
@ bin = $argv[1]
set lac=$argv[2]
#
if (!(-e word)) then
  stderr word : directory not found. ; exit 1
endif
#
@ pv = `awk -v lac=$lac '{ print int(65535*(lac-$1)/($2-$1)+0.5) }' word.log`
if ($pv < 0 || $pv > 65535) then
  stderr $lac : bad LAC threshold. ; exit 1
endif
#
set bev=bev_word_${bin}_$pv
if (-e $bev) then
  stderr $bev : directory already exists. ; exit 1
endif
#
echo $bin $lac $pv | tr ' ' \\t | tee ${bev}.log
#
mkdir ${tmp}.0
si_pnr word - $bin ${tmp}.0
si_mcl ${tmp}.0 - ${pv}- ${tmp}.0 >/dev/null
#
set awk='{ for (y=0; y<$6; y++) for (x=0; x<$3; x++) print $1+$2*x,$4+$5*y }'
echo $lon $lat | awk "$awk" | si_s_bev ${tmp}.0 - 1 $gbbf ${tmp}.1
rm -r ${tmp}.0
#
mkdir $bev
gif_split ${tmp}.1 ${bev}/%d
rm ${tmp}.1
#
set awk=('{ for (y=0; y<$6; y++)' \
           'for (x=0; x<$3; x++)' \
             'system(sprintf("mv %s/%d %s/%03d_%03d.gif",' \
                            'bev,z++,bev,$1+$2*x,$4+$5*y)) }')
echo $lon $lat | awk -v bev=$bev "$awk"
