#!/bin/csh
# usage : test.csh z {DO}
#
set span=-0.5	# span of DO
@ count = 11	# count of DO
#
set sg2tgs=sg2tgs	# CBP by both CUDA and single thread
#set sg2tgs=sg2tgs_wai	# CUDA with angular interpolation
#set sg2tgs=sg2tgs_nai	# single thread without angular interpolation
#set sg2tgs=sg2tgs_int	# single thread with BP by integer arithmetic
#set sg2tgs=sg2tgs_t	# multi-thread CBP
#set sg2tgs=sg2tgs_tnai	# multi-thread without angular interpolation
#set sg2tgs=sg2tgs_tint	# multi-thread with BP by integer arithmetic
#
setenv CUDA_GPU 0	# device number of CUDA-GPU
#setenv CBP_THREADS 4	# number of threads
#
switch($#argv)
  case 1 :
    if (-e DO.tbl) then
      set ab=(`tail -1 DO.tbl | cut -f1-2`)
      stderr using DO at the last line of \"DO.tbl\".
    else
      stderr DO.tbl : file not found. ; exit 1
    endif
    breaksw
  case 2 :
    set ab=(0 $argv[2]) ; breaksw
  default:
    stderr 'usage : test.csh z {DO}' ; exit 1
endsw
#
set z=$argv[1]
#
if (!(-e raw)) then
  stderr raw : directory not found. ; exit 1
endif
#
if ($?PS_CM == 0) then
  setenv PS_CM 0.0001
  stderr "using pixel size (cm) of $PS_CM as the dummy value (warning)."
endif
#
if (!(-e test)) mkdir test
#
dit_tbl raw | hp2sg $z $z test ; if ($status) exit 1
#
if (!(-e test/$z)) set z=`ls test | grep \^0\*0${z}\$`
#
mv test/$z test/${z}.sg
mkdir test/$z
#
set awk='{ printf "%g\t%s\t%s\n",int(($5*$3+$4)/$1-($2-1)/2)*$1,$1,$2 }'
$sg2tgs test/${z}.sg $PS_CM \
        `echo $span $count $ab $z | awk "$awk"` \
        0 16 test/$z | sed "s/^/$z	/g" | tee -a test.log
#
#rm test/${z}.sg
