#!/bin/csh
# usage : trim.csh PV_threshold
#
if ($#argv != 1) then
  stderr usage : trim.csh PV_threshold ; exit 1
endif
#
@ threshold = $argv[1]
#
foreach dir (byte word)
  if (!(-e $dir)) then
    stderr $dir : directory not found. ; exit 1
  endif
end
#
foreach dir (trim trim_xy trim_xz trim_zy)
  if (-e $dir) then
    stderr $dir : directory already exists. ; exit 1
  endif
end
#
set area=(`si_area byte - ${threshold}-`)
echo $threshold $area | tr ' ' \\t | tee trim.log
#
mkdir trim ; si_trim word - $area trim
mkdir trim_xy ; si_trim byte - $area trim_xy
#
mkdir trim_xz ; si_rar trim_xy - +x +z -y trim_xz
mkdir trim_zy ; si_rar trim_xy - +z +y -x trim_zy
