#!/bin/csh
@ frames = 150	# number of frames
@ width = 500	# frame width
set size=20	# font size
@ pv =0		# font PV
#
set name=Helvetica	# font name
set position=RU		# label position
#
set base_step_bps=(0 `echo 1/255 | bc -l` 8)
#
set tmp=/tmp/AAAa$$
#
if (!(-e raw)) then
  stderr raw : directory not found. ; exit 1
endif
#
set dark=raw/d.img
if (!(-e $dark)) then
  set dark=raw/dark.img
  if (!(-e $dark)) then
    stderr $dark : file not found. ; exit 1
  endif
endif
#
mkdir $tmp
#
set awk=('BEGIN { S=N=0 }' \
         'NF==0 { ++S; print }' \
         'NF==2 { if (S==2) L[N++]=$0; else print }' \
         "END { I=int((N+${frames}-1)/${frames});" \
               'for (n=0; n<N; n+=I) print L[n] }')
dit_tbl raw | awk "$awk" | hp2xts $base_step_bps $tmp >/dev/null
#
@ ratio = ( `hp2wl $dark | cut -f1` + ( $width - 1 ) ) / $width
if ($ratio > 1) si_sir $tmp - $ratio $ratio 1 $tmp
#
set awk=('{ TIFF[NR-1]=$1 }' \
         'END { for (nr=0; nr<NR; nr++) printf "%s %g\n",TIFF[nr],180*nr/NR }')
ls ${tmp}/* | awk "$awk" | add_label $name $size $pv $position
#
t2g_movie_gray $tmp - xts.gif
#
rm -r $tmp
